<?php

namespace Binduz\Core\Hook;
require_once( BINDUZ_THEME_DIR . '/app/Plugins/class-tgm-plugin-activation.php');
/**
 * Required Plugins Added.
 * @since 1.0
 * @author quomodosoft.com
 */
class RequiredPlugins
{
	/**
	 * register default hooks and actions for WordPress
	 * @return
	 */
	public function register()
	{
	
        add_action( 'tgmpa_register', [$this,'register_required_plugins'] );

	}

	public function register_required_plugins() {
        //required plugins
       
        $plugins	 = array(
           
            array(
                'name'		 => esc_html__( 'Elementor', 'binduz' ),
                'slug'		 => 'elementor',
                'required'	 => true,
            ),
            array(
                'name'		 => esc_html__( 'Contact form 7', 'binduz' ),
                'slug'		 => 'contact-form-7',
                'required'	 => true,
            ),
            array(
                'name'		 => esc_html__( 'Mailchimp', 'binduz' ),
                'slug'		 => 'mailchimp-for-wp',
                'required'	 => true,
            ),
            array(
                'name'		 => esc_html__( 'Unyson', 'binduz' ),
                'slug'		 => 'unyson',
                'required'	 => true,
            ),
            array(
                'name'		 => esc_html__( 'Classic editor', 'binduz' ),
                'slug'		 => 'classic-editor',
                'required'	 => true,
                
            ),
            
            array(
                'name'		 => esc_html__( 'Classic Widgets Area', 'binduz' ),
                'slug'		 => 'classic-widgets',
                'required'	 => true,
                
            ),
            array(
                'name'		 => esc_html__( 'Element Ready', 'binduz' ),
                'slug'		 => 'element-ready-lite',
                'required'	 => true,
                
            ),  
            array(
                'name'     => esc_html__('WC Shopping Cart','binduz'),
                'slug'     => 'woocommerce-shopping-cart-menu',
                'source'   => get_template_directory() . '/app/Plugins/archive/woocommerce-shopping-cart-menu.zip',
                'required' => false,
            ),
            array(
                'name'		 => esc_html__( 'binduz Essentials', 'binduz' ),
                'slug'		 => 'binduz-essential',
                'required'	 => true,
                'source'     => get_template_directory() . '/app/Plugins/archive/binduz-essential.zip', // The plugin source.
            ),	
        );
    
    
        $config = array(
            'id'			 => 'binduz', // Unique ID for hashing notices for multiple instances of TGMPA.
            'default_path'	 => '', // Default absolute path to bundled plugins.
            'menu'			 => 'binduz-install-plugins', // Menu slug.
            'parent_slug'	 => 'themes.php', // Parent menu slug.
            'capability'	 => 'edit_theme_options', // Capability needed to view plugin install page, should be a capability associated with the parent menu used.
            'has_notices'	 => true, // Show admin notices or not.
            'dismissable'	 => true, // If false, a user cannot dismiss the nag message.
            'dismiss_msg'	 => '', // If 'dismissable' is false, this message will be output at top of nag.
            'is_automatic'	 => true, // Automatically activate plugins after installation or not.
            'message'		 => '', // Message to output right before the plugins table.
        );
    
        tgmpa( $plugins, $config );
    }

}

